#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>

int main()
{
    int N,Q;
    scanf("%d %d", &N,&Q);
    intmax_t d[N], k[Q];
    int p[N];
    for(int i=0; i<N; i++)
    {
        scanf("%I64d %d", &d[i], &p[i]);
    }
    for(int i=0; i<Q; i++)
    {
        scanf("%I64d", &k[i]);
    }

    for(int i=0; i<Q; i++)
    {
        intmax_t stash = 0;
        intmax_t pojedeno = 0;
        int iday = -1;
        for(int j=0; j<N; j++)
        {
            if(d[j] <= k[i])
                iday = j;
        }
        if(iday != -1)
        {
            for(int j=0; j<=iday; j++)
            {
                if(j == 0)
                {
                    stash += p[j]-1;
                    pojedeno++;
                }
                else
                {
                    if(stash - (d[j]-(d[j-1]+1)) < 0)
                    {
                        pojedeno += stash;
                        stash -= d[j]-(d[j-1]+1);
                        stash = 0;
                    }
                    stash += p[j]-1;
                    pojedeno++;
                }
            }
            if(d[iday] < k[i])
            {
                if(stash - (k[i]-(d[iday]+1)) < 0)
                {
                    pojedeno += stash;
                }
                else
                    pojedeno += k[i]-d[iday];
            }
            printf("%I64d\n", pojedeno);
        }
        else
        {
            printf("%d\n", 0);
        }
    }

    return 0;
}